MSYNC(2)

NAME
msync - synchronize a mapped region

LIBRARY
libc

SYNOPSIS
#include <sys/types.h>
#include <sys/mman.h>
int
msync(void *addr, size_t len, int flags);

DESCRIPTION
The msync() system call writes any modified pages back to the filesystem and updates the file modification time. If len is 0, all modified pages within the region containing addr will be flushed; if len is non-zero, only those pages containing addr and len-1 succeeding locations will be examined. The flags argument may be specified as follows:

    MS_ASYNC	Return immediately
    MS_SYNC		Perform synchronous writes
    MS_INVALIDATE	Invalidate all cached data

RETURN VALUES
If any errors occur, -1 is returned and errno is set to indicate the error. Otherwise, a 0 value is returned.

ERRORS
msync() will fail if:

[EINVAL]
    addr is not a multiple of the hardware page size.

[EINVAL]
    len is too large or negative.

[EINVAL]
    flags was both MS_ASYNC and MS_INVALIDATE. Only one of these flags is allowed.

[EIO]
    An I/O error occurred while writing to the file system.

SEE ALSO
madvise(2), mincore(2), mprotect(2), munmap(2)

HISTORY
The msync() function first appeared in 4.4BSD.